#Ask a Pharmacist (AAP) Web Application

There are two components to the Ask A Pharmacist mobile app. The first component will create an Ask A Pharmacist mobile application that will supplement the current mobile caregiver application.  Ask A Pharmacist will include a Frequently Ask Questions (FAQ) Archive on general medication questions, vetted by Pharmacy Benefits Management (PBM), as well as links to internal and external medication resources, maintained and vetted by PBM. The second component will provide a launching point to Secure Messaging within My HealtheVet, including pre-population of contact information for the Veteran’s pharmacy team using a triage group titled “Ask A Pharmacist.”  This will make it much easier for Veterans to contact their pharmacy team and allow pharmacy staff to receive and triage Secure Messages (SMs) from patients and providers in the same manner as a phone call to pharmacy is triaged.

##Project Structure:
<ul>
	<li>acceptance</li>
	<li>app</li>
		<ul>
			<li>img</li>
			<li>css</li>
			<li>js</li>
			<ul>
				<li>libs</li>
				<li>models</li>
				<li>templates</li>
				<li>views</li>
				<li>collections</li>
			</ul>
			<li>index.html</li>
		</ul>
	<li>fortify</li>
	<li>tomcat</li>
</ul>

##Links
<ul>
	<li>Wiki: [https://wiki.serverserver.domain/display/AAP/Ask+a+Pharmacist+App]</li>
	<li>SDD Addendum: [https://wiki.serverserver.domain/display/AAP/Ask+A+Pharmacist+%28AAP%29+SDD+Addendum]</li>
	<li>JIRA: [https://issues.mobilehealth.domain/browse/AAP]</li>
</ul>