
window.AAP = window.AAP || {};
AAP.dataLoaded = false;
AAP.index = $($.parseXML($.ajax({ type: "GET", url: urlPath() + "index.html", async: false }).responseText));
router = new AAP.Router;
domElement = null;
$.getJSON(urlPath() + "js/models/AAP.json", function (json) {
    AAP.appData = json; //This is our apps data.    
    //setup elements
    var els = [];
    els.push(AAP.index.find("body div.aap"));
    els.push(AAP.index.find("body script[type='text/backbone']"));
    els.push(els)
    $("body > #test-append").html(els);
    AAP.dataLoaded = true;
});
beforeEach(function (done) {
    this.routeSpy = sinon.spy();
    try {
        Backbone.history.start({ silent: true, pushState: true });
    } catch (e) { }
    router.navigate("elsewhere");

    //Make sure all data is loaded and dom elements pulled from index and setup for use.
    if (!AAP.dataLoaded) {
        var timer = setInterval(function () {
            if (AAP.dataLoaded) {
                clearInterval(timer);
                done();
            }
        }, 10);
    }
    else { done(); }
});
describe("AAP", function () {

    describe("Object", function () {
        it('AAP should be defined', function () {
            expect(window.AAP).toBeDefined();
        });
    });

    describe("Router", function () {
        it("AAP.Router should be defined", function () {
            expect(router).toBeDefined();
        });
        it("fires the index route with a blank hash", function () {;
            router.bind("route:index", this.routeSpy);
            router.navigate("", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });      
        it("fires the MHV route with #my-healthevet-pharmacy-services in url", function () {
            router.bind("route:MHV", this.routeSpy);
            router.navigate("#my-healthevet-pharmacy-services", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the PBI route with #pill-and-bottle-information in url", function () {
            router.bind("route:PBI", this.routeSpy);
            router.navigate("#pill-and-bottle-information", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the TMR route with #trusted-medication-resources in url", function () {
            router.bind("route:TMR", this.routeSpy);
            router.navigate("#trusted-medication-resources", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the AVP route with #about-va-pharmacies in url", function () {
            router.bind("route:AVP", this.routeSpy);
            router.navigate("#about-va-pharmacies", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the TMM route with #track-my-medications in url", function () {
            router.bind("route:TMM", this.routeSpy);
            router.navigate("#track-my-medications", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the MA route with #medication-articles in url", function () {
            router.bind("route:MA", this.routeSpy);
            router.navigate("#medication-articles", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the DI route with #drug-interactions in url", function () {
            router.bind("route:DI", this.routeSpy);
            router.navigate("#drug-interactions", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the MADMIN route with #medication-administration in url", function () {
            router.bind("route:MADMIN", this.routeSpy);
            router.navigate("#medication-administration", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the CDHSI route with #consumer-drug-herbal-supplement-information in url", function () {
            router.bind("route:CDHSI", this.routeSpy);
            router.navigate("#consumer-drug-herbal-supplement-information", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the SafetyArticles route with #safety-articles in url", function () {
            router.bind("route:SafetyArticles", this.routeSpy);
            router.navigate("#safety-articles", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the Medications route with #medications in url", function () {
            router.bind("route:Medications", this.routeSpy);
            router.navigate("#medications", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the ReportingMedicationErrors route with #reporting-medication-errors in url", function () {
            router.bind("route:ReportingMedicationErrors", this.routeSpy);
            router.navigate("#reporting-medication-errors", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the SafetyPractices route with #safety-practices in url", function () {
            router.bind("route:SafetyPractices", this.routeSpy);
            router.navigate("#safety-practices", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the PillBottle route with #PillBottle in url", function () {
            router.bind("route:PillBottle", this.routeSpy);
            router.navigate("#PillBottle", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the KnowYourMedicationLabel route with #KnowYourMedicationLabel in url", function () {
            router.bind("route:KnowYourMedicationLabel", this.routeSpy);
            router.navigate("#KnowYourMedicationLabel", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the VANationalFormulary route with #VANationalFormulary in url", function () {
            router.bind("route:VANationalFormulary", this.routeSpy);
            router.navigate("#VANationalFormulary", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the HowVAHelpsVeterans route with #HowVAHelpsVeterans in url", function () {
            router.bind("route:HowVAHelpsVeterans", this.routeSpy);
            router.navigate("#HowVAHelpsVeterans", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the HowVAPharmaciesOperate route with #HowVAPharmaciesOperate in url", function () {
            router.bind("route:HowVAPharmaciesOperate", this.routeSpy);
            router.navigate("#HowVAPharmaciesOperate", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });
        it("fires the Not Found route with an invalid value in url", function () {
            router.bind("route:notFound", this.routeSpy);
            router.navigate("#INVALIDROUTE", true);
            expect(this.routeSpy).toHaveBeenCalledOnce();
        });    
    });
    
    describe("LinkCollection", function () {
        beforeEach(function () {
            this.linkCollection = new AAP.LinkCollection([], { id: 1 });
        });
        it('LinkCollection should be defined', function () {
            expect(this.linkCollection).toBeDefined();
        });
    });
    
    describe("BaseModel", function () {
        beforeEach(function () {
            this.linkModel = new AAP.BaseModel();
        });
        it('LinkModel should be defined', function () {
            expect(this.linkModel).toBeDefined();
        });
    });

    describe("Views", function () {
        describe("Index View", function () {         
            beforeEach(function (done) {               
                router.navigate("", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });           
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 5 links", function () {
                expect(domElement.find('a').length).toEqual(5);
            });
            it("Does the view contain a link for My HealtheVet Services", function () {
                expect(domElement.find('a[href$="#my-healthevet-pharmacy-services"]').length).toBe(1);
            });
            it("Does the view contain a link for Pill and Bottle Information", function () {
                expect(domElement.find('a[href$="#pill-and-bottle-information"]').length).toBe(1);
            });
            it("Does the view contain a link for Trusted Medication Resources", function () {
                expect(domElement.find('a[href$="#trusted-medication-resources"]').length).toBe(1);
            });
            it("Does the view contain a link for About VA Pharmacies", function () {
                expect(domElement.find('a[href$="#about-va-pharmacies"]').length).toBe(1);
            });
            it("Does the view contain a link for Send a Secure Message", function () {
                expect(domElement.find('a[href="https://www.myhealth.domain/mhv-portal-web/anonymous.portal?_nfpb=true&_nfto=false&_pageLabel=spotlightArchive&contentPage=spotlight/10162012_SecureMessaging.html"]').length).toBe(1);
            });
            describe("Eula Modal", function () {
                beforeEach(function (done) {
                    $("#aap-content-modal > #eula-modal").remove();
                    done();
                });
                it("Does a modal appear when local storage is not set", function () {
                    localStorage.removeItem('AAP_Eula');
                    if (_.isNull(localStorage.getItem('AAP_Eula'))) {
                        AAP.eulaModal = new AAP.EULAModalView({ model: new AAP.BaseModel({}) }); //Create the Modal
                    }
                    expect($("#eula-modal").length > 0 ? true : false).toBe(true);
                });
                it("Does a modal appear when local storage is set", function () {
                    localStorage.setItem('AAP_Eula', JSON.stringify({ show: false, timestamp: new Date().getTime() }));
                    if (_.isNull(localStorage.getItem('AAP_Eula'))) {
                        AAP.eulaModal = new AAP.EULAModalView({ model: new AAP.BaseModel({}) }); //Create the Modal
                    }
                    expect($("#aap-content-modal > #eula-modal").length < 1 ? true : false).toBe(true);
                });
            });
        });
        describe('My HealtheVet Pharmacy Services View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#my-healthevet-pharmacy-services", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 8 links", function () {
                expect(domElement.find('a').length).toEqual(8);
            });
            it("Does the view contain a 'Rx Refill Guide' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Rx Refill Guide"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Rx Refill' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Rx Refill"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Track My Medications' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Track My Medications"; });
                expect(link.length).toBe(1);              
            });
            it("Does the view contain a 'Prescription History' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Prescription History"; });
                expect(link.length).toBe(1);              
            });
            it("Does the view contain a 'Medication Articles on My HealtheVet' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medication Articles on My HealtheVet"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medical Library' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medical Library"; });
                expect(link.length).toBe(1);              
            });
            it("Does the view contain a 'FAQ - MyHealtheVet' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "FAQ - MyHealtheVet"; });
                expect(link.length).toBe(1);              
            });
            it("Does the view contain a 'Send a Secure Message' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Send a Secure Message"; });
                expect(link.length).toBe(1);              
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));            
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));               
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child("+i+") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
            describe("Leave Site Modal with injected text", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('data-modal-warning')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Pill and Bottle Information View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#pill-and-bottle-information", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 2 links", function () {
                expect(domElement.find('a').length).toEqual(2);
            });
            it("Does the view contain a 'Pill Identification' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Pill Identification"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Pill Bottle Information' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Pill Bottle Information"; });
                expect(link.length).toBe(1);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Trusted Medication Resources View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#trusted-medication-resources", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 7 links", function () {
                expect(domElement.find('a').length).toEqual(7);
            });
            it("Does the view contain a 'Know Your Medication Label' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Know Your Medication Label"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Pill Identification' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Pill Identification"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medication Administration' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medication Administration"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medication Disposal' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medication Disposal"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Consumer Drug, Herbal & Supplement Information' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Consumer Drug, Herbal & Supplement Information"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'FAQ - VA National Medication Formulary' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "FAQ - VA National Medication Formulary"; });
                expect(link.length).toBe(1);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('About VA Pharmacies View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#about-va-pharmacies", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 3 links", function () {
                expect(domElement.find('a').length).toEqual(3);
            });
            it("Does the view contain a 'How VA Pharmacists Help Veterans' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "How VA Pharmacists Help Veterans"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'How VA Pharmacies Operate' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "How VA Pharmacies Operate"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Find My Facility' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Find My Facility"; });
                expect(link.length).toBe(1);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Track My Medications View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#track-my-medications", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 3 links", function () {
                expect(domElement.find('a').length).toEqual(3);
            });
            it("Does the view contain a 'Prescription Tracker - FAQ' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Prescription Tracker - FAQ"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'UPS My Choice' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "UPS My Choice"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'USPS' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "USPS"; });
                expect(link.length).toBe(1);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Medication Articles View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#medication-articles", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 12 links", function () {
                expect(domElement.find('a').length).toEqual(12);
            });
            it("Does the view contain a 'Medications: Keep Track and Play It Safe' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medications: Keep Track and Play It Safe"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Navigating Your Way to Good Health: Finding Reliable Information Online' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Navigating Your Way to Good Health: Finding Reliable Information Online"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Thinking about Quitting Smoking? - Medications Can Help' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Thinking about Quitting Smoking? - Medications Can Help"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medications: Playing it Safe at Home' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medications: Playing it Safe at Home"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medication Check Up' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medication Check Up"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medicine Cabinet Full? Too Many Pills?' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medicine Cabinet Full? Too Many Pills?"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Check Your Medications: A Prescription for Better Health' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Check Your Medications: A Prescription for Better Health"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medication Disposal Safety Tips' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medication Disposal Safety Tips"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'VA's Mail-Order Pharmacy Program Recognized 2011' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "VA's Mail-Order Pharmacy Program Recognized 2011"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'What Vaccines do you need?' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "What Vaccines do you need?"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Sharing Your Health Information' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Sharing Your Health Information"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Viewing your VA Medication Names' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Viewing your VA Medication Names"; });
                expect(link.length).toBe(1);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Drug Interactions View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#drug-interactions", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 2 links", function () {
                expect(domElement.find('a').length).toEqual(2);
            });
            it("Does the view contain a 'Adverse Drug Event Information' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Adverse Drug Event Information"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Drug Interaction Articles' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Drug Interaction Information"; });
                expect(link.length).toBe(1);
            });               
        });
        describe('Drug Interaction Articles View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#drug-interaction-articles", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 4 links", function () {
                expect(domElement.find('a').length).toEqual(4);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Medication Administration View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#medication-administration", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 1 links", function () {
                expect(domElement.find('a').length).toEqual(1);
            });           
            it("Does the view contain a 'How to properly administer a medication' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "How to properly administer a medication"; });
                expect(link.length).toBe(1);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Consumer Drug, Herbal & Supplement Information View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#consumer-drug-herbal-supplement-information", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 4 links", function () {
                expect(domElement.find('a').length).toEqual(4);
            });
            it("Does the view contain a 'Get the latest Safety Articles on Medications' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Get the latest Safety Articles on Medications"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medications' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medications"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Reporting Medication Errors' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Reporting Medication Errors"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Safety Practices' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Safety Practices"; });
                expect(link.length).toBe(1);
            });                      
        });
        describe('Get the latest Safety Articles on Medications View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#safety-articles", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 2 links", function () {
                expect(domElement.find('a').length).toEqual(2);
            });
            it("Does the view contain a 'Free Medication Alerts' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Free Medication Alerts"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Recalls, Market Withdrawals, & Safety Alerts on FDA' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Recalls, Market Withdrawals, & Safety Alerts on FDA"; });
                expect(link.length).toBe(1);
            });     
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });               
        describe('Reporting Medication Errors View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#reporting-medication-errors", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 2 links", function () {
                expect(domElement.find('a').length).toEqual(2);
            });
            it("Does the view contain a 'FDA MedWatch' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "FDA MedWatch"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Report A Medication Error' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Report A Medication Error"; });
                expect(link.length).toBe(1);
            });         
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Safety Practices View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#safety-practices", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 4 links", function () {
                expect(domElement.find('a').length).toEqual(4);
            });
            it("Does the view contain a 'Medicine Safety: A Toolkit for Families' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medicine Safety: A Toolkit for Families"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medication Tips & Tools on Safemedication.com' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medication Tips & Tools on Safemedication.com"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Safe Disposal of Medicines on FDA' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Safe Disposal of Medicines on FDA"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'VA Center for Medication Safety' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "VA Center for Medication Safety"; });
                expect(link.length).toBe(1);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Drug Interaction Information', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#drug-interaction-articles", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 4 links", function () {
                expect(domElement.find('a').length).toEqual(4);
            });
            it("Does the view contain a 'Drugs with Food & Beverages' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Drugs with Food & Beverages"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Drugs with Dietary Supplements' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Drugs with Dietary Supplements"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Drugs with Other Drugs' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Drugs with Other Drugs"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Tips to Avoid Problems' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Tips to Avoid Problems"; });
                expect(link.length).toBe(1);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Adverse Drug Event Information', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#adverse-drug-event-information", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it("Does the view contain 4 links", function () {
                expect(domElement.find('a').length).toEqual(4);
            });
            it("Does the view contain a 'Drug Interactions Checker' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Drug Interactions Checker"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medline Allergy Information' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medline Allergy Information"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Report adverse drug events to FDA MedWatch' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Report adverse drug events to FDA MedWatch"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Track adverse drug events in FDA' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Track adverse drug events in FDA"; });
                expect(link.length).toBe(1);
            });
        });
        describe('Get the latest Safety Articles on Medications', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#safety-articles", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it("Does the view contain 2 links", function () {
                expect(domElement.find('a').length).toEqual(2);
            });
            it("Does the view contain a 'Free Medication Alerts' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Free Medication Alerts"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Recalls, Market Withdrawals, & Safety Alerts on FDA' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Recalls, Market Withdrawals, & Safety Alerts on FDA"; });
                expect(link.length).toBe(1);
            });
        });
        describe('Medications View', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#medications", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it('view should be defined', function () {
                expect(AAP.index).toBeDefined();
            });
            it("Does the view contain 3 links", function () {
                expect(domElement.find('a').length).toEqual(3);
            });
            it("Does the view contain a 'Food and Drug Administration' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Food and Drug Administration"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medline Plus' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medline Plus"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Veterans Health Library' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Veterans Health Library"; });
                expect(link.length).toBe(1);
            });
            describe("Leave Site Modal", function () {
                var userPref;
                beforeEach(function (done) {
                    links = domElement.find('a');
                    //save localstorage setting
                    userPref = JSON.parse(localStorage.getItem('AAP_Modal'));
                    //update localstorage setting for test
                    localStorage.setItem('AAP_Modal', JSON.stringify({ show: true, timestamp: new Date().getTime() }));
                    for (i = 0; i < links.length; i++) {
                        if ($(links[i]).data('external')) {
                            i = links.length;
                            $(".link-container:nth-child(" + i + ") a").trigger("click");
                        }
                    }
                    done();
                });
                it("Does a modal appear when external links are clicked", function () {
                    expect($("#aap-modal").length > 0 ? true : false).toBe(true);
                });
                afterEach(function () {
                    //reset localstorage setting
                    localStorage.setItem('AAP_Modal', JSON.stringify(userPref));
                });
            });
        });
        describe('Reporting Medication Errors', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#reporting-medication-errors", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it("Does the view contain 2 links", function () {
                expect(domElement.find('a').length).toEqual(2);
            });
            it("Does the view contain a 'FDA MedWatch' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "FDA MedWatch"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Report A Medication Error' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Report A Medication Error"; });
                expect(link.length).toBe(1);
            });
        });
        describe('Safety Practices', function () {
            beforeEach(function (done) {
                var link = false;
                router.navigate("#safety-practices", true);
                setTimeout(function () {
                    domElement = $("#aap-link");
                    done();
                }, 25);
            });
            it("Does the view contain 4 links", function () {
                expect(domElement.find('a').length).toEqual(4);
            });
            it("Does the view contain a 'Medicine Safety: A Toolkit for Families' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medicine Safety: A Toolkit for Families"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Medication Tips & Tools on Safemedication.com' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Medication Tips & Tools on Safemedication.com"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'Safe Disposal of Medicines on FDA' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "Safe Disposal of Medicines on FDA"; });
                expect(link.length).toBe(1);
            });
            it("Does the view contain a 'VA Center for Medication Safety' link", function () {
                link = domElement.find('a').filter(function (index) { return $(this).find('.link-title').text() === "VA Center for Medication Safety"; });
                expect(link.length).toBe(1);
            });
        });
        describe('About Modal', function () {
            beforeEach(function (done) {
                if($("nav").length < 1){
                    var navigationData = { //build data
                        "app-name": AAP.appData["app-name"],
                        "links": AAP.appData.navigation
                    };
                    AAP.navigation = new AAP.NavigationView({ model: new AAP.BaseModel(navigationData) }); //Create the Nav
                }
                $(".tablet-nav > li:nth-child(3) a").trigger("click");
                setTimeout(function () {
                    //domElement = $("#aap-modal-content");
                    elDefined = ($("#aap-content-modal > #aap-modal-content").length) > 0 ? true : false;
                    done();
                }, 25);
            });
            it('Modal should be created and displayed on link click event', function () {          
                expect(elDefined).toBeDefined();
            });
            afterEach(function () {
                $('#aap-modal-content').modal('hide');
                $('#aap-content-modal').empty();
            });
        });
        describe('Help Modal', function () {
            beforeEach(function (done) {
                if ($("nav").length < 1) {
                    var navigationData = { //build data
                        "app-name": AAP.appData["app-name"],
                        "links": AAP.appData.navigation
                    };
                    AAP.navigation = new AAP.NavigationView({ model: new AAP.BaseModel(navigationData) }); //Create the Nav
                }
                $(".tablet-nav > li:nth-child(4) a").trigger("click");
                setTimeout(function () {
                    //domElement = $("#aap-modal-content");
                    elDefined = ($("#aap-content-modal > #aap-modal-content").length) > 0 ? true : false;
                    done();
                }, 25);
            });
            it('Modal should be created and displayed on link click event', function () {
                expect(elDefined).toBeDefined();
            });
            afterEach(function () {
                $('#aap-modal-content').modal('hide');
                $('#aap-content-modal').empty();
            });
        });
    });

    describe("Handlebars Tests", function () {
        describe('ifequal helper tests', function () {
            var fields, html;
            beforeEach(function () {
                this.fields = { first: "123" };
                this.html = "{{#ifequal first last}}true{{else}}false{{/ifequal}}";
            });
            it('will return false when the values are not equal', function () {
                var template = Handlebars.compile(this.html);
                this.fields['last'] = 123;
                var result = template(this.fields);
                expect(result).toEqual("false");
            });
            it('will return true when the values are equal', function () {
                var template = Handlebars.compile(this.html)
                this.fields['last'] = "123";
                var result = template(this.fields)
                expect(result).toEqual("true");
            });
        });

        describe('unless_blank helper tests', function () {
            var fields, html;
            beforeEach(function () {
                fields = { title: "" };
                html = $("#pageTitleTemplate").html();
            });
            it('will return valid html when the values are set', function () {
                var template = Handlebars.compile(html)
                fields = { title: "MHV" };
                var result = template(fields);
                expect(result.trim()).toMatch('<h1 class="page-heading vertically-center">MHV</h1>');
            });
            it('will return an empty sting when the values are not set', function () {
                var template = Handlebars.compile(html)
                fields = { title: "" };
                var result = template(fields);       
                expect(result.trim()).toMatch('');
            });
        });

        describe('HTML helper tests', function () {
            var fields, html;
            beforeEach(function () {
                this.fields = { title: "" };
                this.html = "{{HTML title}}";
            });
            it('will return valid html when html is stored in a string', function () {
                var template = Handlebars.compile(this.html)
                this.fields['title'] = "My Health<strong><em>e</em></strong>Vet Pharmacy Services";
                var result = template(this.fields);
                expect(result).toMatch('My Health<strong><em>e</em></strong>Vet Pharmacy Services');
            });
            it('will return valid html when no html is stored in a string', function () {
                var template = Handlebars.compile(this.html);
                this.fields['title'] = "My HealtheVet Pharmacy Services";
                var result = template(this.fields);
                expect(result).toMatch("My HealtheVet Pharmacy Services");
            });
        });

    });

    describe("Page Elements", function () {
        describe('Navigation Elements', function () {
            var html, navView;
            beforeEach(function () {           
                html = $('#aap-nav');
                var navigationData = { //build data
                    "app-name": AAP.appData["app-name"],
                    "links": AAP.appData.navigation
                };
                AAP.navigation = new AAP.NavigationView({ model: new AAP.BaseModel(navigationData) }); //Create the Nav
                
            });
            it('view should be defined', function () {
                expect(AAP.navigation).toBeDefined();
            });
            it("Header information to include Ask a Pharmacist application name", function () {
                expect(html.find('a.navbar-brand').text()).toMatch("Ask a Pharmacist");
            });
            it('Header information to include a "Home" link', function () {
                expect(html.find('.tablet-nav > li:first-child > a').text()).toMatch("Home");
            });
            it('Header information to include a "Features" link', function () {
                expect(html.find('.tablet-nav > li:nth-child(2) > a').text()).toMatch("Features");
            });
            describe("Features sub-links", function () {
                it('"Features" dropdown contains a "My HealtheVet Pharmacy Services" link', function () {
                    expect(html.find('.tablet-nav > li:nth-child(2) .dropdown-menu li:nth-child(1)').text()).toMatch("My HealtheVet Pharmacy Services");

                });
                it('"Features" dropdown contains a "Pill and Bottle Information" link', function () {
                    expect(html.find('.tablet-nav > li:nth-child(2) .dropdown-menu li:nth-child(2)').text()).toMatch("Pill and Bottle Information");

                });
                it('"Features" dropdown contains a "Trusted Medication Resources" link', function () {
                    expect(html.find('.tablet-nav > li:nth-child(2) .dropdown-menu li:nth-child(3)').text()).toMatch("Trusted Medication Resources");
                });
                it('"Features" dropdown contains a "About VA Pharmacies" link', function () {
                    expect(html.find('.tablet-nav > li:nth-child(2) .dropdown-menu li:nth-child(4)').text()).toMatch("About VA Pharmacies");
                });
                it('"Features" dropdown contains a "Send a Secure Message" link', function () {
                    expect(html.find('.tablet-nav > li:nth-child(2) .dropdown-menu li:nth-child(5)').text()).toMatch("Send a Secure Message");
                });
            });
            it('Header information to include a "About" link', function () {
                expect(html.find('.tablet-nav > li:nth-child(3) > a').text()).toMatch("About");
            });
            it('Header information to include a "Help" link', function () {
                expect(html.find('.tablet-nav > li:nth-child(4) > a').text()).toMatch("Help");
            });        
        });    
        describe("General Page elements", function () {
            beforeEach(function () {
                var footerData = { //build data
                    "developed-by": AAP.appData.about["developed-by"],
                    "address": AAP.appData.address,
                    "app-version": AAP.appData["app-version"],
                    "last-update-date": AAP.appData["last-update-date"],
                };
                AAP.banner = new AAP.BannerView({ model: new AAP.BaseModel(AAP.appData.banner) }); //Create the banner
                AAP.footer = new AAP.FooterView({ model: new AAP.BaseModel(footerData) }); //Create the footer
            });
            it("Header information to include VA Health brand logo", function () {
                expect($("#bannerContainer").find('.va-banner').find("img").length).toEqual(1);
            });
            it("Header include link back to launchpad", function () {
                //div#header-login.dropdown a#login.btn-link
                expect($("#bannerContainer").find('#login.btn-link').length).toEqual(1);
            });
            it("div#mainContainer should exist on page", function () {
                expect($(".aap").find('#mainContainer').length).toEqual(1);
            });
            it("div#aap-link should exist on page", function () {
                expect($("body").find('#aap-link').length).toEqual(1);
            });
            it("footer element should exist on page", function () {
                expect($("#footerContainer").find('footer').length).toEqual(1);
            });
        });       
    });
 
    describe("User Authenticated", function () {
        beforeEach(function (done) {
            //Make sure all data is loaded and dom elements pulled from index and setup for use.
            if (!AAP.dataLoaded) {
                var timer = setInterval(function () {
                    if (AAP.dataLoaded) {
                        clearInterval(timer);
                        AAP.token = false;
                        AAP.userAuthenticated();
                        if (AAP.getSessionToken() != null && AAP.getSessionToken().length > 1) {
                            AAP.token = true;
                        }
                        done();
                    }
                }, 10);
            }
            else {
                AAP.token = false;
                AAP.userAuthenticated();
                if (AAP.getSessionToken() != null && AAP.getSessionToken().length > 1) {
                    AAP.token = true;
                }
                done();
            }
        });
        it('User is authenticated if token is present', function () {
            expect(AAP.token).toBe(AAP.appData.banner.user.authenticated);
        });
    });

});
afterEach(function () {
    router.navigate("js/tests/SpecRunner.html");
    $(".scrollbar-gradient").remove();
    $("body").attr("style", "").removeClass("modal-open");
});