package gov.va.vamf.aap.tomcat.security;


import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.SecretKeySpec;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class Encryptor {
	
	private static Encryptor enc = null;

    private static final String ALGORITHM = "AES";

    private static final String defaultSecretKey = "ThisIsAVeryVerySecretKey";

    private Key secretKeySpec;

    public Encryptor() throws InvalidKeyException, NoSuchAlgorithmException, NoSuchPaddingException,
            UnsupportedEncodingException {
        this(null);
    }

    public Encryptor(String secretKey) throws NoSuchAlgorithmException, NoSuchPaddingException, InvalidKeyException,
            UnsupportedEncodingException {
        this.secretKeySpec = generateKey(secretKey);
    }

    public String encrypt(String plainText) throws InvalidKeyException, NoSuchAlgorithmException,
            NoSuchPaddingException, IllegalBlockSizeException, BadPaddingException, UnsupportedEncodingException {
        Cipher cipher = Cipher.getInstance(ALGORITHM);
        cipher.init(Cipher.ENCRYPT_MODE, secretKeySpec);
        byte[] encrypted = cipher.doFinal(plainText.getBytes("UTF-8"));
        return asHexString(encrypted);
    }

    public String decrypt(String encryptedString) throws InvalidKeyException, IllegalBlockSizeException,
            BadPaddingException, NoSuchAlgorithmException, NoSuchPaddingException {
        Cipher cipher = Cipher.getInstance(ALGORITHM);
        cipher.init(Cipher.DECRYPT_MODE, secretKeySpec);
        byte[] original = cipher.doFinal(toByteArray(encryptedString));
        return new String(original);
    }

    private Key generateKey(String secretKey) throws UnsupportedEncodingException, NoSuchAlgorithmException {
        if (secretKey == null) {
            secretKey = defaultSecretKey;
        }
        byte[] key = (secretKey).getBytes("UTF-8");
        MessageDigest sha = MessageDigest.getInstance("SHA-512");
        key = sha.digest(key);
        key = Arrays.copyOf(key, 16); // use only the first 128 bit

        KeyGenerator kgen = KeyGenerator.getInstance("AES");
        kgen.init(256); // 192 and 256 bits may not be available

        return new SecretKeySpec(key, ALGORITHM);
    }

    private final String asHexString(byte buf[]) {
        StringBuffer strbuf = new StringBuffer(buf.length * 2);
        int i;
        for (i = 0; i < buf.length; i++) {
            if (((int) buf[i] & 0xff) < 0x10) {
                strbuf.append("0");
            }
            strbuf.append(Long.toString((int) buf[i] & 0xff, 16));
        }
        return strbuf.toString();
    }

    private final byte[] toByteArray(String hexString) {
        int arrLength = hexString.length() >> 1;
        byte buf[] = new byte[arrLength];
        for (int ii = 0; ii < arrLength; ii++) {
            int index = ii << 1;
            String l_digit = hexString.substring(index, index + 2);
            buf[ii] = (byte) Integer.parseInt(l_digit, 16);
        }
        return buf;
    }
    

    public static Encryptor getInstance() throws Exception{
    	if(enc == null) {
    		enc = new Encryptor();
    	}
    	return enc;
    }

    public static void main(String[] args) throws Exception {
    	if(args.length>0) {
    		System.out.println(Encryptor.getInstance().encrypt(args[0]));
    	} else {

        	final JFrame frm = new JFrame();
        	frm.setLayout(new BorderLayout());
        	
        	//userName
        	JPanel userNamePanel = new JPanel(new BorderLayout());
        	final JLabel userNameLabel = new JLabel("Username:");
        	final JTextField userNameField = new JTextField();
        	userNamePanel.add(userNameLabel,BorderLayout.NORTH);
        	userNamePanel.add(userNameField,BorderLayout.CENTER);
        	frm.add(userNamePanel,BorderLayout.NORTH);
        	
        	//password
        	JPanel pwdPanel = new JPanel(new BorderLayout());
        	final JLabel pwdLabel = new JLabel("Password:");
        	JButton go = new JButton("Encrypt");
        	final JTextField passwordField = new JTextField();
        	pwdPanel.add(pwdLabel,BorderLayout.NORTH);
        	pwdPanel.add(passwordField,BorderLayout.CENTER);
        	pwdPanel.add(go,BorderLayout.SOUTH);
        	
        	frm.add(pwdPanel,BorderLayout.CENTER);
        	
        	//encrypted panel
        	JPanel encryptedPanel = new JPanel(new BorderLayout());
        	final JLabel encrptedUsernameLabel = new JLabel("Encrypted Username:");
        	final JTextField encrpytedUserNameField = new JTextField();
        	encrpytedUserNameField.setEditable(false);
        	final JLabel encrptedPwdLabel = new JLabel("Encrypted Password:");
        	final JTextField encrpytedPwdField = new JTextField();
        	encrpytedPwdField.setEditable(false);
        	
        	JPanel encryptedUserPanel = new JPanel(new BorderLayout());
        	JPanel encryptedPwdPanel = new JPanel(new BorderLayout());
        	encryptedPanel.add(encryptedUserPanel,BorderLayout.NORTH);
        	encryptedPanel.add(encryptedPwdPanel,BorderLayout.CENTER);
        	encryptedUserPanel.add(encrptedUsernameLabel,BorderLayout.NORTH);
        	encryptedUserPanel.add(encrpytedUserNameField,BorderLayout.CENTER);       	
        	encryptedPwdPanel.add(encrptedPwdLabel,BorderLayout.NORTH);
        	encryptedPwdPanel.add(encrpytedPwdField,BorderLayout.CENTER);
        	
        	frm.add(encryptedPanel,BorderLayout.SOUTH);
        	
        	go.addActionListener(new ActionListener(){
    			@Override
    			public void actionPerformed(ActionEvent e) {
    				try {
    					encrpytedUserNameField.setText(Encryptor.getInstance().encrypt(userNameField.getText()));
    					JOptionPane.showMessageDialog(frm, "Decryption check: "+ Encryptor.getInstance().decrypt(encrpytedUserNameField.getText()));
    					encrpytedPwdField.setText(Encryptor.getInstance().encrypt(passwordField.getText()));
    					JOptionPane.showMessageDialog(frm, "Decryption check: "+ Encryptor.getInstance().decrypt(encrpytedPwdField.getText()));
    				} catch (Exception e1) {
    					e1.printStackTrace();
    					JOptionPane.showMessageDialog(frm, e1.getMessage());
    				}
    			}
        	});
        	frm.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        	frm.setSize(800,220);
        	frm.setLocationRelativeTo(null);
        	frm.setVisible(true);
    	}
    

    }

}
